<?php

/**
 * This Software is the property of D Data Development
 * and is protected by copyright law - it is NOT Freeware.
 *
 * Any unauthorized use of this software without a valid license
 * key is a violation of the license agreement and will be
 * prosecuted by civil and criminal law.
 *
 * Inhaber: Thomas Dartsch
 * Alle Rechte vorbehalten
 *
 * @package "Bonuspunkte"
 * @author Thomas Dartsch <thomas.dartsch@shopmodule.com>
 * @copyright (C) 2012, D3 Data Development
 * @see http://www.shopmodule.com
 *
 * $Rev::                                               $:
 * $Author::                                            $:
 * $Date::                                              $:
 */

ini_set('display_errors', 1);
ini_set('error_reporting', 1);


require_once dirname(__FILE__) . "/../../../../bootstrap.php";

/**
 * Class d3_Cron_Points
 */
class d3_Cron_Points extends oxSuperCfg
{
    /**
     * Secret Key fr den Aufruf des Script per Browser
     *
     * @var string
     */
    protected $_sDefaultAccessKey = "H78hbk32Jofjeo";
    private $_sModId = 'd3points';
    protected $_sLogType = d3log::ERROR;

    /**
     * init Class
     * Prft auf Konsolen-Zugriff und startet die ntigen weiteren Methoden
     *
     */
    public function init()
    {
        //Shopid setzten
        $sShopId = d3_d3points_utils::d3_d3pointsUtils_CheckShopId();
        oxRegistry::getConfig()->setShopId($sShopId);


        //Modul aktiv
        if (!$this->getModCfg()->isActive())
        {
            $this->d3Log()->Log(d3log::INFO, __CLASS__, __FUNCTION__, __LINE__, "Modul Bonuspunkte nicht aktiv", "nicht aktiv");
            //todo Uebesetzung
            echo "Modul Bonuspunkte nicht aktiv";
            oxRegistry::getSession()->freeze();
            exit();
        }

        $this->getModCfg()->setValue('d3points_CronJob_NEWPOINTS_LastStart', date('Y-m-d H:i:s'));
        $this->getModCfg()->saveNoLicenseRefresh();

        $this->d3Log()->Log(d3log::INFO, __CLASS__, __FUNCTION__, __LINE__, "Starting CronJob-Bonuspunkte, Shop: " . $sShopId);

        $sGetAccessKey = oxRegistry::getConfig()->getRequestParameter('key');
        $sValidAccessKey = $this->getModCfg()->getValue('d3points_ACCESSKEY');

        if (!$sValidAccessKey)
            $sValidAccessKey = $this->_sDefaultAccessKey;
        if (($_SERVER['REMOTE_ADDR'] || $_SERVER['HTTP_USER_AGENT']) && $sValidAccessKey != $sGetAccessKey)
        {
            $this->d3Log()->Log(d3log::CRITICAL, __CLASS__, __FUNCTION__, __LINE__, "shutdown", " access with browser!. ");
            die("security shutdown");
        }

        //CronJob aktiv
        if ($this->getModCfg()->getValue('bld3points_CRONJOB_ACTIVE') == false)
        {
            $this->d3Log()->Log(d3log::INFO, __CLASS__, __FUNCTION__, __LINE__, "CronJob nicht aktiv", "nicht aktiv");
            //todo Uebesetzung
            echo "CronJob Punktevergabe nicht aktiv";
            oxRegistry::getSession()->freeze();
            exit();
        }

        //Go to d3points an perform some actions
        if (class_exists('d3_d3points_d3points')) {
            /** @var $od3points d3_d3points_d3points */
            $od3points = oxnew('d3_d3points_d3points');
            $ret = 'Start CronJob';
            $sStatus       = $od3points->d3StartCronJobActions();
            if($this->getModCfg()->getValue('bld3points_FNC_CRONJOB_PRINT_STATUS') == true)
            {
                $ret.= $sStatus;
            }
        } else {
            $ret = 'Classs d3_d3points_d3points not exist.';
        }

        $this->d3Log()->Log(d3log::INFO, __CLASS__, __FUNCTION__, __LINE__, "End CronJob-Bonuspunkte Report", $ret);

        $ret.='<br>End CronJob';

        oxRegistry::getSession()->freeze();
        exit(nl2br($ret));
    }

    /**
     * */
    public function getModCfg()
    {
        return d3_cfg_mod::get($this->_sModId);
    }

    /**
     * @return d3log
     */
    public function d3Log()
    {
        return $this->getModCfg()->d3getLog();
    }

}
$oBV = new d3_Cron_Points;
$oBV->init();